'V_DSound.inc 
'Version 0.01  ; 29.03.2007 by Volta
'Version 0.01a ; 31.03.2007 fr FB016b + FB017
'Version 0.02  ; 21.05.2007 kleine Codenderungen, luft in einem Spiel sehr stabil
'Version 0.1   ; 07.06.2007 kl. Tutorial dafr  erstellt

#Include once "windows.bi" 
#include once "win/mmsystem.bi" 
#Include once "win/dsound.bi" 

Dim Shared As LPDIRECTSOUND V_DSound         'das Zentrale DirectSound-Objekt 
Dim Shared As LPDIRECTSOUNDBUFFER DSPrimBuf  'der Primre Sounpuffer 
Dim Shared As HWND V_DShwnd
Dim Shared As WAVEFORMATEX wFormat           ' Daten des Ausgabeformats
Dim Shared As Integer V_DS_Wformat_is_set = 0
Redim Shared DSWorkBuf(0 To 1) As LPDIRECTSOUNDBUFFER

declare Function V_DSExit As Integer

Sub V_DSMsg (Byval text As String, Byval Fnr As Integer = 0)
  MessageBox(V_DShwnd, "Fehler " + Chr(10,10) + text + ".", "V_DSound", MB_ICONERROR + MB_OK)
  if Fnr = 1 then End 1
    'V_DSExit
    End 1
  'end if
End Sub

'die Einstellung des Ausgabeformats des Soundpuffers
Sub V_DSWAVEFORMAT (Byval v_Channels As Integer = 2,Byval v_SamplesPerSec As Integer = 22050, _
                    Byval v_BitsPerSample As Integer = 16)
  With wFormat
    .wFormatTag = WAVE_FORMAT_PCM           ' welches Format ?
    .nChannels = v_Channels                 ' 2 Kanle
    .nSamplesPerSec = v_SamplesPerSec       ' 22,050Khz Samplingrate
    .wBitsPerSample = v_BitsPerSample       ' 16 Bits / Sample
    .nBlockAlign = .wBitsPerSample / 8 * .nChannels 
    .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign 
  End With
  V_DS_Wformat_is_set = -1
End Sub


Function V_DSinit (Byval hwnd As HWND) As Integer
  Dim erg As HRESULT
  Dim soundBuffDesc As DSBUFFERDESC   'Beschreibung des Soundpuffers 
  V_DShwnd = hwnd
  'Erstellen des zentralen DirectSound-Objektes
  erg = DirectSoundCreate(NULL, @V_DSound, NULL)
  If erg <> DS_OK Then 
    V_DSMsg("bei Create DirectSound-Objekt")
    Return erg
  End If
  
  'Kooperationsebene setzen 
  'DSSCL_NORMAL  1  Normaler Zugriff auf das Audiogert (=Soundkarte), 
  '  andere Anwendungen haben auch Zugriff darauf.
  'DSSCL_PRIORITY  2  Wir haben erweiterte Zugriffsrechte und Prioritt beim Zugriff 
  '  auf Hardwareressourcen, die wir uns aber trotzdem noch mit anderen Anwendungen, 
  '  die die gleiche Soundkarte nutzen, teilen mssen.
  'DSSCL_EXCLUSIVE  3  Wir haben exklusives Zugriffrecht auf das Audiogert, 
  '  andere Anwendungen haben keinen Zugriff mehr darauf.
  'DSSCL_WRITEPRIMARY  4  Hchstes Zugriffsrecht. Wir knnen direkt in den Speicher schreiben.
  erg = IDirectSound_SetCooperativeLevel(V_DSound, V_DShwnd, DSSCL_PRIORITY)
  If erg <> DS_OK Then 
    V_DSMsg("bei SetCooperativeLevel")
    Return erg
  End If
  
  'Beschreibung des Soundpuffers fllen 
  With soundBuffDesc
    .dwSize = Sizeof(soundBuffDesc) 'DX-Standard
    .dwFlags = DSBCAPS_PRIMARYBUFFER'primrer SoundPuffer
    .dwBufferBytes = 0  'Puffergrsse muss 0 Byte sein fr primren Puffer
    .lpwfxFormat = NULL 'Pufferformat muss NULL sein fr primren Puffer
  End With
  'Soundpuffer erzeugen 
  erg = IDirectSound_CreateSoundBuffer(V_DSound, @soundBuffDesc, @DSPrimBuf, NULL)
  If erg <> DS_OK Then 
    V_DSMsg("bei Create DirectSoundPuffer")
    Return erg
  End If
  
  If V_DS_Wformat_is_set = 0 Then V_DSWAVEFORMAT
  erg = IDirectSoundBuffer_SetFormat(DSPrimBuf, @wFormat) 
  If erg <> DS_OK Then 
    If DSPrimBuf <> NULL Then IDirectSoundBuffer_Release(DSPrimBuf) 'primren Puffer frei geben 
    V_DSMsg("kann Ausgabeformat nicht setzen")
    Return erg
  End If
  
  Function =0
End Function


Function V_DSLoadWave (Byref V_DSWorkBuf As LPDIRECTSOUNDBUFFER, Byval Wavename As String) As Integer
  'Der erste Teil ldt die Datei
  Dim As HMMIO wavefile
  Dim As MMCKINFO parent, child
  Dim As WAVEFORMATEX wavefmt
  Dim As DSBUFFERDESC bufdesc
  Dim As Byte Ptr write1, write2
  Dim As Uinteger length1,length2
  Dim erg As HRESULT 
  wavefile = mmioOpen (Wavename, 0, MMIO_READ Or MMIO_ALLOCBUF)
  If wavefile = 0 Then 
    V_DSMsg("beim laden von " + Wavename)
    Return -1
  End If 
  'ist WAVE Datei?
  parent.fccType = mmioFOURCC("W", "A", "V", "E")
  mmioDescend(wavefile, @parent, 0, MMIO_FINDRIFF)
  'welches PCM-Format?
  child.fccType = mmioFOURCC("f", "m", "t", " ")
  mmioDescend(wavefile, @child, @parent, 0)
  mmioRead(wavefile, Cast(Byte Ptr, @wavefmt), Sizeof(wavefmt))
  If wavefmt.wFormatTag <> WAVE_FORMAT_PCM Then
    mmioClose(wavefile, 0)  'Wave-Datei schlieen
    V_DSExit
    V_DSMsg(Wavename + " hat kein PCM-Format!",1)
  End If
  If wavefmt.nChannels <> wFormat.nChannels Then
    mmioClose(wavefile, 0)  'Wave-Datei schlieen
    V_DSExit
    V_DSMsg(Wavename + " Channels?",1)
  End If
  If wavefmt.nSamplesPerSec <> wFormat.nSamplesPerSec Then
    mmioClose(wavefile, 0)  'Wave-Datei schlieen
    V_DSExit
    V_DSMsg(Wavename + " Samplingrate?",1)
  End If
  If wavefmt.wBitsPerSample <> wFormat.wBitsPerSample Then
    mmioClose(wavefile, 0)  'Wave-Datei schlieen
    V_DSExit
    V_DSMsg(Wavename + " Bits / Sample?",1)
  End If
  
  'Wo sind die PCM-Daten?
  mmioAscend(wavefile, @child, 0)
  child.ckid = mmioFOURCC("d", "a", "t", "a")
  mmioDescend (wavefile, @child, @parent, MMIO_FINDCHUNK)
  'Anhand des Formates der Wave-Daten nun einen Soundpuffer erzeugen
  With bufdesc
    .dwSize = Sizeof(DSBUFFERDESC)
    .dwFlags = DSBCAPS_STATIC Or _
               DSBCAPS_GLOBALFOCUS Or _
               DSBCAPS_CTRLPAN Or _
               DSBCAPS_CTRLVOLUME Or _
               DSBCAPS_CTRLFREQUENCY
    .dwBufferBytes = child.cksize
    .lpwfxFormat = @wavefmt
  End With
  erg = IDirectSound_CreateSoundBuffer(V_DSound, @bufdesc, @V_DSWorkBuf, NULL) 
  If erg <> DS_OK Then 
    mmioClose(wavefile, 0)  'Wave-Datei schlieen
    V_DSMsg("kann Soundpuffer nicht erzeugen") 
    V_DSExit
    End 1
  End If
  
  'Sounddaten der Wavedatei in Arbeits-Soundpuffer lesen
  'wir mssen den Puffer sperren (LOCK) und erhalten einen Zeiger auf die Sounddaten
  '- da kopieren wir die Wavedaten dann hin.
  erg = IDirectSoundBuffer_Lock(V_DSWorkBuf, 0, bufdesc.dwBufferBytes, @write1, @length1, @write2, @length2, 0)
  If erg <> DS_OK Then 
    mmioClose(wavefile, 0)  'Wave-Datei schlieen
    V_DSMsg("kann Soundbuffer nicht benutzen") 
    Return erg
  End If 
  'nun die Wave-Daten in den Soundpuffer bertragen
  If write1 > 0 Then mmioRead(wavefile, write1, length1)
  'wenn length1 kleiner als die gesammte Pufferlnge dann zeigt write2 auf den restlichen Teil
  If write2 > 0 Then mmioRead(wavefile, write2, length2)
  'Soundpuffer wieder entsperren
  IDirectSoundBuffer_Unlock(V_DSWorkBuf, write1, length1, write2, length2)
  mmioClose(wavefile, 0)  'Wave-Datei schlieen
  Function =0
End Function


Function V_DSExit As Integer
  Dim i As Integer
  For i = 0 To Ubound(DSWorkBuf)
    If DSWorkBuf(i) <> NULL Then IDirectSoundBuffer_Release(DSWorkBuf(i))
  Next
  If DSPrimBuf <> NULL Then IDirectSoundBuffer_Release(DSPrimBuf) 
  If V_DSound  <> NULL Then IDirectSound_Release(V_DSound) 
  Function =0
End Function


Function V_DSLoadSound(Byval Buffer As Integer, Byval filename As String, Byval Anzahl_Buffer As Integer = 1) As Integer
  Dim As Integer i, n, erg = -1
  i = Ubound(DSWorkBuf)
  n = Buffer + Anzahl_Buffer - 1
  If n > i Then 
    Redim Preserve DSWorkBuf(0 To n) As LPDIRECTSOUNDBUFFER
  End If
  If DSWorkBuf(Buffer) <> NULL Then IDirectSoundBuffer_Release(DSWorkBuf(Buffer))
  erg = V_DSLoadWave (DSWorkBuf(Buffer), filename)
  For i = n To Buffer+1 Step -1
    If erg = 0 Then
      If DSWorkBuf(i) <> NULL Then IDirectSoundBuffer_Release(DSWorkBuf(i))
      erg = IDirectSound_DuplicateSoundBuffer(V_DSound, DSWorkBuf(Buffer), @DSWorkBuf(i))
    End If
  Next
  Function = erg
End Function


'V_DStart(Buffer)
Function V_DStart(Byval Buffer As Integer) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  IDirectSoundBuffer_SetCurrentPosition(DSWorkBuf(Buffer), 0)
  Function = IDirectSoundBuffer_Play(DSWorkBuf(Buffer), 0, 0, 0)
End Function


'V_DSPlay_one(byval Buffer As Integer, byval Anzahl_Buffer As Integer = 1)
Function V_DSPlay_one(Byval Buffer As Integer, Byval Anzahl_Buffer As Integer = 1) As Integer
  Dim As Integer i, dstatus
  For i = Buffer To Buffer + Anzahl_Buffer -1
    If DSWorkBuf(i) = 0 Then Return -1
    IDirectSoundBuffer_GetStatus(DSWorkBuf(i),@dstatus)
    If dstatus = 0 Then 
      IDirectSoundBuffer_SetCurrentPosition(DSWorkBuf(i), 0)
      Function = IDirectSoundBuffer_Play(DSWorkBuf(i), 0, 0, 0)
      Exit Function
    End If
  Next
  Function = -1
End Function


'V_DS_Playloop(Buffer)
Function V_DSPlayloop(Byval Buffer As Integer) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  Function = IDirectSoundBuffer_Play(DSWorkBuf(Buffer), 0, 0, DSBPLAY_LOOPING)
End Function


Function V_DSStop(Byval Buffer As Integer) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  Function = IDirectSoundBuffer_Stop(DSWorkBuf(Buffer))
End Function


'position = V_DSGetPos(Buffer)
'position liefert den Wert in Bytes vom Bufferanfang
Function V_DSGetPos(Byval Buffer As Integer) As Integer
  Dim As Integer p, dummy
  If DSWorkBuf(Buffer) = 0 Then Return -1
  IDirectSoundBuffer_GetCurrentPosition(DSWorkBuf(Buffer),@p, @dummy)
  Function = p
End Function


'V_DSSetPos(Buffer, position) noch nicht ganz klar!
Function V_DSSetPos(Byval Buffer As Integer, Byval position As Integer = 0) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  IDirectSoundBuffer_SetCurrentPosition(DSWorkBuf(Buffer),position)
End Function


'volumen = V_DSGetVol(Buffer)
Function V_DSGetVol(Byval Buffer As Integer) As Integer
  Dim v As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  IDirectSoundBuffer_GetVolume(DSWorkBuf(Buffer),@v)
  Function = v
End Function


'V_DSSetVol(Buffer, volumen)
'DirectSound kann die Lautstrke eines Sounds nicht erhhen, sondern nur verringern.
'Darum sind auch nur negative Werte erlaubt (DSBVOLUME_MIN -10000 .. 0 DSBVOLUME_MAX).
Function V_DSSetVol(Byval Buffer As Integer, Byval volumen As Integer = 0) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  If volumen < DSBVOLUME_MIN Then volumen = DSBVOLUME_MIN
  If volumen > DSBVOLUME_MAX Then volumen = DSBVOLUME_MAX
  IDirectSoundBuffer_SetVolume(DSWorkBuf(Buffer),volumen)
End Function


'pan = V_DSGetPan(Buffer)
Function V_DSGetPan(Byval Buffer As Integer) As Integer
  Dim p As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  IDirectSoundBuffer_GetPan(DSWorkBuf(Buffer),@p)
  Function = p
End Function


'V_DSSetPan(Buffer, pan)
'Wert zwischen -10000 (100% links, 0% rechts) und +10000 (0% links, 100% rechts)
Function V_DSSetPan(Byval Buffer As Integer, Byval pan As Integer = 0) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  If pan < -10000 Then pan = -10000
  If pan > 10000 Then pan = 10000
  IDirectSoundBuffer_SetPan(DSWorkBuf(Buffer),pan)
End Function


'frequenz = V_DSGetFreq(Buffer)
Function V_DSGetFreq(Byval Buffer As Integer) As Integer
  Dim f As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  IDirectSoundBuffer_GetFrequency(DSWorkBuf(Buffer),@f)
  Function = f
End Function


'V_DSSetFreq(Buffer, frequenz)
Function V_DSSetFreq(Byval Buffer As Integer, Byval frequenz As Integer) As Integer
  If DSWorkBuf(Buffer) = 0 Then Return -1
  If frequenz < 100 Or frequenz > 100000 Then Return -1
  IDirectSoundBuffer_SetFrequency(DSWorkBuf(Buffer),frequenz)
End Function

